import com.ibm.aglet.*;
import com.ibm.aglet.event.*;
import java.net.*;
import java.io.*;
import java.net.URL;
import java.security.Security;
import java.security.*;
import java.math.BigInteger;
import java.math.*;
import java.util.*;

/**
 * This application does the encryption and decryption functions of the MMH
 * cryptosystem. It encrypts the  two integers(x1 and x2) whose multiplication operation is to
 * be subcontrated to the host at the deatination URL. It creates the "MMHEncryptDecrypt"
 * aglet and dispatches it to the destination where the multiplication is done on the
 * encrypted integers. The result is then returned to the sending host using the message
 * exchange and then decrypted and printed to the console.
 *
 */
public class MMHEncrDecrAgletApp extends Aglet {


	public void run() {
		BigInteger encResult;
		BigInteger p = new BigInteger("11");
		BigInteger q = new BigInteger("7");
		BigInteger n = new BigInteger("77");
		BigInteger x1 = new BigInteger("5");
		BigInteger x2 = new BigInteger("2");
		BigInteger r = new BigInteger("3");

		System.out.println("\n");
		System.out.println("The value of first integer (X1) is = " +x1);
		System.out.println("The value of second integer (X2) is = " +x2);
		System.out.println("The value of p is = " +p);
		System.out.println("The value of q is = " +q);
		System.out.println("The value of r is = " +r);
		System.out.println("\n");

/**
 * a1 and a2 are the encrypted values of the integers x1 and x2
 * respectively. The encryption is done using the MMH cryptosystem
 */
		BigInteger a1 = x1.add((r.multiply(p)));
		BigInteger a2 = x2.add((r.multiply(p)));

		System.out.println("The encrypted value of X1 which is x1.add((r.multiply(p))) = " +a1);
		System.out.println("The encrypted value of X2 which is x2.add((r.multiply(p))) = " +a2);
		System.out.println("\n");



		try {
			Object args = new Object[] {
					a1,
					a2,
					n };

			/**URL destination = new URL("atp://LIFEBOOK:3000");**/
			URL destination = new URL("atp://jaypanda-4:3000");
/**
 * The MMHEncryptDecrypt aglet proxy is created and dispatched to the
 * destination.
 */
			System.out.println("Creating and Dispatching the proxy aglet to the destination...");
       		System.out.println("\n");
			AgletProxy  proxy = getAgletContext().createAglet(getCodeBase(), "MMHEncryptDecrypt", args);
			proxy = proxy.dispatch(destination);
/**
 * Message is sent to the aglet proxy at the destination and the result
 * is collected.
 */
			Message myResult = new Message("result");
			BigInteger Result = (BigInteger)proxy.sendMessage(myResult);
			System.out.println("\n");
			System.out.println("Retracting the result from the proxy aglet by Message passing...");
			System.out.println("\n");
			System.out.println("The product of encrypted X1 and X2 returned from the destination by message passing is " +Result);
			System.out.println("\n");
/**
 * The collected result is decrypted and printed to the console
 */
 			System.out.println("Decrypting the result....");
			System.out.println("\n");
			BigInteger decryptedResult = Result.mod(p);


			System.out.println("The decrypted product of X1 and X2 which is (encrypted product x mod(p))  = " +decryptedResult);
			System.out.println("\n");

/** The aglet proxy is retracted from the destination and disposed
 */

		    proxy = getAgletContext().retractAglet(destination,proxy.getAgletID());
			proxy.dispose();

			System.out.println("Retracting and disposing the aglet....");
 			System.out.println("\n");

		}catch(MalformedURLException e) {

		}catch(Exception e) {


		}finally {

		}
	}
}
